package brownstrategy;

import java.util.Stack;

import brownstrategy.agent.Agent;
import brownstrategy.agent.DeterministicAgent;
import brownstrategy.agent.NondeterministicAgent;
import game.Game;
import game.Strategy;

//Returns the Perrin Sequence
// vshah and ddufresn

public class PerrinStrategy extends NondeterministicAgent {

	int a = 3;
	int b = 0;
	int c = 2;
	Stack<Integer> aStack;
	Stack<Integer> bStack;
	Stack<Integer> cStack;

	public PerrinStrategy(Game g, long seed, String options) {
		super(g,seed,options);
		aStack = new Stack<Integer>();
		bStack = new Stack<Integer>();
		cStack = new Stack<Integer>();
	}

	@Override
	public Agent getCopy() {
		return new PerrinStrategy(_g,_seed,_options);
	}

	@Override
	public Agent getCopy(Game g, long seed, String options) {
		return new PerrinStrategy(g,seed,options);
	}

	@Override
	public double[] getActionDistribution() {
		if(_day == _cacheDay) {
			return _cacheDist;
		}
		_cacheDist = new double[12];
		_cacheDay = _day;
		int tempa = a;
		int tempb = b;
		a=b;
		b=c;
		c= (tempa+tempb)%12;
		_cacheDist[c] = 1;
		return _cacheDist;
	}

	@Override
	public void observeOutcome(int[] actions) {
		_day++;
	}
	
	@Override
	public void lookAhead(int[] actions) {
		aStack.push(a);
		bStack.push(b);
		cStack.push(c);
		observeOutcome(actions);
	}

	@Override
	public void lookBack() {
		a = aStack.pop();
		b = bStack.pop();
		c = cStack.pop();
		_day--;
	}

}
