package brownstrategy.agent;

import game.Game;
import brownstrategy.oracles.UniformDistributionOracle;

/**
 * An agent that has models of its opponents. These models are automatically
 * updated as the agent receives new information.
 * 
 * @author sodomka
 *
 */
public abstract class ModelBasedAgent extends NondeterministicAgent {
	
	protected Agent predictor1, predictor2;
	
	public ModelBasedAgent(Game g, long seed, String options) {
		super(g, seed, options);
		predictor1 = new UniformDistributionOracle(g,seed,options);
		predictor2 = new UniformDistributionOracle(g,seed,options);
	}
	
	public void setPredictors(Agent opp1Predictor, Agent opp2Predictor) {
		predictor1 = opp1Predictor;
		predictor2 = opp2Predictor;
	}
	
	public void observeOutcome(int[] actions) {
		_day++;
	}
	
}
