package strategy;

import game.Game;
import game.Strategy;
import game.Utility;
import java.util.Random;
import lemonade.LemonadeUtility;
import strategy.Player;

/* Author: Dustin Morrill
 * Date: August 25, 2010
 *
 * Agent description:
 * This is the object that contains information relating to all players in
 * a lemonade game (such as rank by utility).
 *
 */

public class Agents {
    Player players[];
    int total_rank[];
    int latest_rank[];
    int constant_rank[];
    int target_label;

    public Agents (int num_players) {
        players = new Player[num_players];
        for (int i = 0; i < players.length; i++) {
            players[i] = new Player(i);
        }
        total_rank = new int[num_players];
        latest_rank = new int[num_players];
        constant_rank = new int[num_players];
        target_label = -1;
    }

    public Player[] getPlayerArray () {
        return players;
    }

    public void setTotalRank (int rank[]) {
        System.arraycopy(rank, 0, total_rank, 0, rank.length);
    }

    public int[] getTotalRank () {
        return total_rank;
    }
    
    public void setLatestRank (int rank[]) {
        System.arraycopy(rank, 0, latest_rank, 0, rank.length);
    }

    public int[] getLatestRank () {
        return latest_rank;
    }

    public void setTargetLabel (int label) {
        target_label = label;
    }

    public int getTargetLabel () {
        return target_label;
    }

    public void setConstantRank (int rank[]) {
        System.arraycopy(rank, 0, constant_rank, 0, rank.length);
    }

    public int[] getConstantRank () {
        return constant_rank;
    }
}

