/**
 * 
 */
package edu.cmu.psy.reitter.meta;

import java.util.ArrayDeque;
import java.util.Deque;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Random;
import java.util.Vector;

import game.Game;

import edu.cmu.psy.reitter.meta.UtilityBasedStrategy;
import strategy.*;

/**
 * @author enrique
 *
 */
public class EAsquared extends UtilityBasedStrategy {

 private Vector<Integer> sequence = new  Vector<Integer>();;
 private int currentAction = r.nextInt(11);
 private Agent opponents[] = new Agent[2];
 private int timeStep;
 private static int initialStick = 5; //how many time steps to stick to initial strategy
 private Counter stickCounter; // = new Counter(initialStick);
 private static final int T = 1; //how many time steps to stick to current strategy
 private int currentUtility = 0;
 /**
  * @param g
  * @param seed
  */
 public EAsquared(Game g, long seed, String options) {
  super(g, seed);
  timeStep = 0;
  for (int i = 0; i < g.getNumPlayers()-1; i++) {
   opponents[i] = new Agent(numActions);
  }
  stickCounter = new Counter(initialStick);
 }
 
  @Override
 public void observeOutcome(int[] actions){
     currentAction = actions[0];
     for (int i = 0; i < opponents.length; i++) {
   opponents[i].lastAction(actions[i+1], actions[0]);
  }
     int[] possibleUtilities = getPossibleUtilities(actions);
     currentUtility = possibleUtilities[currentAction];
     sequence.add(currentAction);
  computeStrat();
  timeStep++;
 }

 /* (non-Javadoc)
  * @see strategy.UtilityBasedStrategy#observeUtilities(int[], int)
  */
 @Override
 public void observeUtilities(int[] possibleUtilities, int currentAction) {
   //TODO Auto-generated method stub
 }

 /* (non-Javadoc)
  * @see game.Strategy#getAction()
  */
 @Override
 public int getAction() {
  return currentAction;
 }
 
 /**
  * THIS FUNCTION IS THE ONE TO BE PLAYED WITH 
  * up to now the strategy sticks if somebody is in front of it
  * or follows agent 1
  * @return the return type is dummy
  * TODO: find the code best strategy :P
  */
 private void computeStrat(){
  double tol = 0.1; 
  
  Random generator = new Random();
    
  double s_0 = opponents[0].stickIndex(); // stick index of agent 0
  double f_0  = opponents[0].followIndex(sequence, opponents[1].getSequence()); //full follow index
  double f_01 = opponents[0].followIndex(opponents[1].getSequence()); // partial follow index
  double f_02 = opponents[0].followIndex(sequence);
  
  double s_1 = opponents[1].stickIndex();
  double f_1  = opponents[1].followIndex(sequence, opponents[0].getSequence());  
  double f_10 = opponents[1].followIndex(opponents[0].getSequence());
  double f_12 = opponents[1].followIndex(sequence);
  
// Now for the list of conditional statements:
//  System.out.println( opponents[0].getSequence());
//  System.out.println("s_0 = " + s_0 + " f_0 = " + f_0);
//  System.out.println( opponents[1].getSequence());
//  System.out.println("s_1 = " + s_1 + " f_1 = " + f_1);

//  STICK COUNTER SECTION
  // if stickCount is positive, stick 
  if (stickCounter.getCount() > 0) {
	  stickCounter.decreaseCount();
//   System.out.println("Stick counter > 0");
//   currentAction = currentAction;
	// however, if both opponents have not moved for 3 then we should move into bigger gap
	   if ((s_0 == 0)&&(s_1 == 0)&&(sequence.size()>2)&&(currentUtility<6)) {
		   currentAction = (currentAction+6) % 12;
	   }
  }
  // If stickCounter is set to less than -1, this is the signal to employ stick and carrot strategy
  else if (stickCounter.getCount() <= -1){
	  currentAction = carrotAndStick();
  }

//   STICKY SECTION
  // if 0 is a sticker and the stickiest, and stickier than 1 is followy, follow 0 
  else if ( (s_0 >= f_0 + tol) && (s_0 >= f_1 + tol) && (s_0 >= s_1 + tol) ) {
   currentAction = opposite(0);
//   stickCounter.setCount(T);
//   System.out.println("follow stickiest");
  }
  // if 1 is a sticker and the stickiest, and stickier than 0 is followy, follow 1
  else if ( (s_1 >= f_1 + tol) && (s_1 >= f_0 + tol) && (s_1 >= s_0 + tol) ) { 
   currentAction = opposite(1);
//   stickCounter.setCount(T);
//   System.out.println("follow stickiest");
  }
  
  // if both are stickers...
  else if 
   ( (s_0 > f_0 + tol) && (s_1 > f_1 + tol) ) {
   // ...and payoff is high, stick.
   if ( currentUtility > 7 ) { 
//    currentAction = currentAction;
//    System.out.println("two stickers, high payoff, so stick");
   } 
   //...otherwise, if payoff is low, follow stickiest.
   else { 
    int stickiest = 0;
    if (s_1 > s_0) // find stickiest opponent
     stickiest = 1;   
    currentAction = opposite(stickiest); // play opp stickiest... 
    stickCounter.setCount(T); // stick there for 2
//    System.out.println("two stickers, low payoff, so move to the bigger gap");
   }
  } 


//FOLLOWY Section  
// if 0 is a follower and the followiest, and followier than 1 is followy...
	else if ( (f_0 >= s_0 + tol) && (f_0 >= s_1 + tol) && (f_0 >= f_1 + tol) ) { 
	//...and if 0 is following 1, try to interlope
		if ( f_01 >= f_02 + tol ){ 
			currentAction = opponents[1].currentAction();
	//System.out.println("Sit opposite the follower, try to make it follow you");
		}
	//...but if 0 not obviously following 1, stick
	// this is important, because it backs up the Carrot and Stick strategy
		else {
	//currentAction = currentAction;
	//System.out.println("Lead the follower");
		}
	} 
	// if 1 is a follower and the followiest, and followier than 0 is followy...
	else if ( (f_1 >= s_1 + tol) && (f_1 >= s_0 + tol) && (f_1 >= f_0 + tol) ) { 
	//..and if 1 is following 0, try to interlope
		if (f_10 >= f_12 + tol) { 
			currentAction = opponents[0].currentAction();
		//System.out.println("Sit opposite the follower, try to make it follow you");
		}
	//...but if 1 not obviously following 0, stick
	// this is important, because it backs up the Carrot and Stick strategy
		else { 
	//currentAction = currentAction;
	//System.out.println("Lead the follower");
		}
	} 
	
	// if both are followers, and of similar strength...
	else if ( (f_0 > s_0 + tol)&& (f_1 > s_1 + tol) ) {
	//...and following each other...
		if ( (f_01 > f_02 + tol) && (f_10 > f_12 + tol) ) { //
			int followiest = 0;
		if (f_1 > f_0) // find followiest opponent
			followiest = 1;   
		currentAction = opponents[followiest].currentAction(); // play on followiest... 
	//System.out.println("two followers, sit on followiest to be in the bigger gap");
	}
}

//  CARROT AND STICK SECTION
  else if (areSittingOpposite() == 1){
	  stickCounter.setCount(-5);
	  currentAction = carrotAndStick(); 
  }
  
//  CATCHER SECTION
  else {// This would catch the method if none of the conditions are satisfied
//    currentAction = currentAction;
//    System.out.println("No condition satisfied, high utility, so stick");
  }
 }

//	StickCounter used to signal stick and carrot strategy	
	public int carrotAndStick(){
		int cas = -1;
		int follower = 0;
		int sticker = 1;
		if (opponents[1].stickIndex() < opponents[0].stickIndex()){
			follower = 1;
			sticker = 0;
		}
		int	bestSide = showingBias(follower, sticker); 
		// best side, relative to sticker, has a natural BR superiority.
		// 1 is up, -1 is down 
		if (stickCounter.getCount() < -4){
			// condition the best response to play on bestSide
			stickCounter.increaseCount();
			cas =  (opposite(sticker) + bestSide) % 12;
			if (cas == 12){
				cas = 0;
			}
		}
		else if (stickCounter.getCount() == -4){
			stickCounter.increaseCount();
			// condition the best response to exclude playing opposite sticker
			cas =  opposite(sticker);
		}
		else if (stickCounter.getCount() == -3){
			stickCounter.increaseCount();
			// exploit best response
			cas = (opposite(sticker) + 2*bestSide)% 12;
			if (cas == 12){
				cas = 0;
			}
		}
		else if (stickCounter.getCount() == -2){
			stickCounter.increaseCount();
			// exploit best response  
			cas = opposite(sticker);
			if (cas == 12){
				cas = 0;
			}
		}
		else if (stickCounter.getCount() == -1){
			stickCounter.increaseCount();
			// exploit best response  
			stickCounter.setCount(2);
			cas = (opposite(sticker) + 4*bestSide)% 12;
			if (cas == 12){
				cas = 0;
			}
		}
		assert(cas != -1);
		return cas;
	}

	public int areSittingOpposite() {
		int oppTestLength = 5;
		Vector<Integer> zerosActions = opponents[0].getSequence() ;
	//	System.out.println("zeros Actions " + zerosActions);
		Vector<Integer> onesActions = opponents[1].getSequence() ;
	//	System.out.println("ones Actions " + onesActions);
		int sittingOpposite = 1; 
		int index = onesActions.size() - 1;
		while (index > onesActions.size()-(oppTestLength + 1)&& index >= 0 && sittingOpposite == 1){
			int opp1 = (onesActions.get(index) + 6) % 12;
			if (opp1 == 12 ){
				opp1 = 0;
			}
			if (zerosActions.get(index) != opp1){
				sittingOpposite = 0;
			}
			index--;
//			System.out.println("index " + index);
		}
		return (int) sittingOpposite;
	}

	public int opposite(int i){
		int opp = ( (opponents[i].currentAction() + 6) % 12 );
		if (opp == 12){
			opp = 0;
		}
		return opp;
	}

	public int showingBias(int i, int j){
		int lookBack = 10;
		int side = 1;
		Vector<Integer> followsSeq = opponents[i].getSequence();
		int sticksAct = opponents[j].currentAction();
		int upSide = 0;
		int downSide = 0;
		for (int a = lookBack + 5 ; a == 5 ; a--){
			if ((followsSeq.get(timeStep - a) - sticksAct )% 12 > 6 ){
			upSide++;
			}
			else if ((followsSeq.get(timeStep - a) - sticksAct )% 12 < 6 ){
			downSide++;
			} 
		}
		if (upSide < downSide){
			side = 0;
		}
		return side;
	}
}

class Counter{ // Counter class for stickCounter, and any other counters
    public int count;
    
    public Counter(int initialStick) {count = initialStick;}
    
    public void setCount(int newCount) {count = newCount;}
    public void increaseCount() {count++;}
    public void decreaseCount() {count--;}
    public int getCount() {return count;}  
}


/**
 * @author enrique
 *
 */
class Agent{
 int numActions;
// private double stick = 6; //values range from 0 to 6
 //private Map<Boolean, Double> followIndex = new HashMap<Boolean, Double>();
 private int strat[];
 private Vector<Integer> sequence = new  Vector<Integer>();
 private Deque<Integer> pastActions;
 private static final int CAPACITY = 10;
 private static final double GAMMA = 0.75;
 private static final double RHO = 0.5;
 private int myLastActions[];
 
 protected Agent(int actions){
  this.numActions = actions;
  strat = new int[numActions];
  myLastActions = new int[2];
  java.util.Arrays.fill(strat,0);
  pastActions = new ArrayDeque<Integer>(CAPACITY);
  java.util.Arrays.fill(myLastActions,-1);
 }
 
 protected void lastAction(int hisAction, int myAction){
  strat[hisAction]++;
  sequence.add(hisAction);
  if(pastActions.size() >= CAPACITY)
   pastActions.removeLast();
  pastActions.addFirst(hisAction);
  myLastActions[1] = myLastActions[0];
  myLastActions[0] = myAction;
 }
 
 protected void actionCorr(int myAction, int otherOpponent, int hisOwnAction){
 }
 
 protected boolean isFollowing(){
  //TODO: needs test
  if(myLastActions[1] == 0){
   if(pastActions.getFirst() == 6)
    return true;
   else return false;
  }
  else{
   if(pastActions.getFirst() == 12 % (myLastActions[1] + 6))
    return true;
   else return false;
  }
 }
 
 /**
  * computes the followIndex of a given sequence
  * @param opponentSeq the sequence to compare to
  * @return the normalized followIndex of the its sequence and the argument's sequence
  * @TODO: work out the co-domain (range) of the function 
  */
 protected double followIndex(Vector<Integer> mySeq, Vector<Integer> otherSeq){
  double fIndex = 0;
  double sumG = 0;
  double dif;
  double dif1;
  double dif2;
  double norm;
  int t = 0;
  assert(this.sequence.size() == mySeq.size() && this.sequence.size() == otherSeq.size());
  for (int i = 0; i < sequence.size(); i++) 
   sumG += Math.pow(GAMMA, i);
  
  for(int i = sequence.size()-1; i >0 ; i--) {
   dif1 = Math.abs((sequence.get(i) -  mySeq.get(i-1) + 6) % 12);
   if(dif1 > 6)
    dif1 = 12 - dif1;
   dif2 = Math.abs((sequence.get(i) - otherSeq.get(i-1) + 6) % 12);
   if(dif2 > 6)
    dif2 = 12 - dif2;
   dif = Math.min(dif1, dif2);
   if(t==0) // System.out.print(dif+": ");
   dif = Math.pow(dif, RHO);
   norm = Math.pow(GAMMA, t) / sumG;
   fIndex += norm * dif;
   t++;
  }
//  System.out.println(fIndex);
  fIndex = - fIndex;
  return fIndex;
 }
 
 /**
  * computes the followIndex of a given sequence for a given opponent
  * @param opponentSeq the sequence to compare to
  * @return the normalized followIndex of the its sequence and the argument's sequence
  * @TODO: work out the co-domain (range) of the function 
  */
 protected double followIndex(Vector<Integer> otherSeq){
  double fIndex = 0;
  double sumG = 0;
  double dif;
  double norm;
  int t = 0;
  assert(this.sequence.size() ==  otherSeq.size());
  for (int i = 0; i < sequence.size(); i++) 
   sumG += Math.pow(GAMMA, i);
  
  for(int i = sequence.size()-1; i >0 ; i--) {
   dif = Math.abs((sequence.get(i) - otherSeq.get(i-1) + 6) % 12);
   if(dif > 6)
    dif = 12 - dif;
   if(t==0) // System.out.print(dif+": ");
   dif = Math.pow(dif, RHO);
   norm = Math.pow(GAMMA, t) / sumG;
   fIndex += norm * dif;
   t++;
  }
//  System.out.println(fIndex);
  fIndex = - fIndex;
  return fIndex;
 }
 
 /**
  * computes its stickIndex
  * @return the normalized stickness value
  */
 protected double stickIndex(){
  double sIndex = 0;
  double sumG = 0;
  double dif;
  double norm;
  int t = 0;
  for (int i = 0; i < sequence.size(); i++) 
   sumG += Math.pow(GAMMA, i);
  
  for(int i = sequence.size()-1; i >0 ; i--) {
   dif = Math.min(Math.abs(sequence.get(i) - sequence.get(i-1)), 
     Math.abs(sequence.get(i-1) - sequence.get(i)));
   if(dif > 6)
    dif = 12 - dif;
   if(t==0) // System.out.print(dif+": ");
   dif = Math.pow(dif,RHO);
   norm = Math.pow(GAMMA, t) / sumG;
   sIndex += norm * dif;
   t++;
  }
//  System.out.println(sIndex);
  sIndex = - sIndex;
  return sIndex;
 }
 
 protected Vector<Integer> getSequence(){
  return sequence;
 }
 
 protected boolean isLeader(){
  // TODO Auto-generated method stub
  return false;
 }
 protected int currentAction(){
  return pastActions.getFirst();
 }
}