/* Authors :
 */

package edu.cmu.psy.reitter.meta;

import game.Game;
import game.Strategy;
import game.Utility;
import java.util.Random;
import lemonade.LemonadeUtility;
import static java.lang.Math.*;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.*;

public class StickySharp implements Strategy{
	
	public final int MAX_HISTORY_STORE = 105;
	public final int LOOKUP_FACTOR = 2;
	public final int FIRST_LEVEL_HISTORY = 4;
	public final int SECOND_LEVEL_HISTORY = 3;
	public final int THIRD_LEVEL_HISTORY = 2;
	public final int NUM_PLAYERS = 3;
	
    Utility utility;
    Random random;

    int count;
    int action0[] = new int [MAX_HISTORY_STORE];
    int action1[] = new int [MAX_HISTORY_STORE];
    int action2[] = new int [MAX_HISTORY_STORE];
    int utility0[] = new int [MAX_HISTORY_STORE];
    int utility1[] = new int [MAX_HISTORY_STORE];
    int utility2[] = new int [MAX_HISTORY_STORE];
    
    int sticky;
public StickySharp (Game g, long seed, String options) {
      utility = g.getUtility();
      count = 0;
      random = new Random (seed);
      sticky = random.nextInt()%12;
}

  /* Implementation of sticky sharp actions */
  public int stickySharp(){
	  if (count ==0){
		  return random.nextInt()%12;
	  }
	  else if(count < LOOKUP_FACTOR)
	  {
		  int[] sum = new int [NUM_PLAYERS];
		  int weakest = 0;
		  for(int i =0; i<NUM_PLAYERS;i++)
			  sum[i] =0;
		  for (int i = 0; i < count;i++)
		  {
			  sum[0] +=  utility0[count-1-i];			  
			  sum[1] +=  utility1[count-1-i];			
			  sum[2] +=  utility2[count-1-i];
		  }
		  if (sum[0] > sum[1])
			  weakest = 1;
		  if (sum[weakest] > sum[2])
			  weakest = 2;
		  if (weakest ==0){
			  return action0[count-1] +1;
		  }
		  else {
			  return action0[count-1];
		  }
	  }	  
	  else 
	  {
		  if (weakest() ==0){
			  return action0[count-1] +1;  
		  }
		  else {
			  return action0[count-1];
		  }
	  }
  }



  @Override
  public int getAction() {

      int action = stickySharp();
      count++;

	  action = action%12;
	  if (action<0)
	      action += 12;

	  return action;

  }
  
  
  public int weakest ()
  {
	  int[] sum = new int [NUM_PLAYERS];
	  int weakest = 0;
	  for (int i =0;i<sum.length;i++)
		  sum[i]=0;
	  for (int i = 0;i < LOOKUP_FACTOR;i++ ) // 
	  {
		  sum[0] += utility0[count-1-i];
		  sum[1] += utility1[count-1-i];
		  sum[2] += utility2[count-1-i];
	  }
	  if (sum[0] > sum[1])
		  weakest = 1;
	  if (sum[weakest] > sum[2])
		  weakest = 2;
	  return weakest;	  
  }
    
  
  
  
  /* Called at the end of each round returning the actions taken by the players,
     Stores the actions in three seperate integer arrays, and gets the utilities
     to be stored in seperate arrays for utilities */
  @Override
  public void observeOutcome(int[] actions) {
      action0[count-1]=actions[0];
      //System.out.println(actions[0]);
      action1[count-1]=actions[1];
      //System.out.println(actions[1]);
      action2[count-1]=actions[2];
      //System.out.println(actions[2]);
      utility0[count-1]=utility.getUtility(actions)[0];
      //System.out.println(utility.getUtility(actions)[0]);
      utility1[count-1]=utility.getUtility(actions)[1];
      //System.out.println(utility.getUtility(actions)[1]);
      utility2[count-1]=utility.getUtility(actions)[2];
      //System.out.println(utility.getUtility(actions)[2]);
  }
}
