package edu.umd.cs.jay;
import strategy.*;

import java.util.Random;

import game.Game;
import lemonade.*;


public class Pujara extends UtilityBasedStrategy  {
	int constantAction;
	int totalUtility=0;

	int badCount=0;
	int goodCount=0;

	int badCutoff = 4;
	int goodCutoff = 5;

	double badThresh = 8;
	double goodThresh = 10;

	GeneralizedLemonadeUtility utility;


	protected void getUtilityInformation() {
		int[] utilDensity = utility.getIslandDensity();
		totalUtility = 0;
		for(int i = 0; i < utilDensity.length; i++){
			totalUtility+=utilDensity[i];
		}
		badThresh = totalUtility/3;
		goodThresh = (totalUtility/3)*1.4;
		//System.out.println("Utility total="+totalUtility+" thresh good, bad="+goodThresh+", "+badThresh);
	}

	protected int sampleActions(){
		
		int utilityTarget = r.nextInt(totalUtility);
		//int utilityTarget = r.nextInt(5);
		int[] utilDensity = utility.getIslandDensity();
		int cumDensity=0;
		for(int i = 0; i < utilDensity.length; i++){
			cumDensity+=utilDensity[i];
			if(cumDensity>utilityTarget){
				return i;
			}
		}
		return utilDensity.length;
	}

	public Pujara(Game g, long seed, String options) {
		super(g, seed);
		utility = (GeneralizedLemonadeUtility)g.getUtility();
		getUtilityInformation();
		
		Random r = new Random(seed);
		constantAction = sampleActions();
	}

	@Override
	public void observeUtilities(int[] possibleUtilities, int currentAction) {
		if(possibleUtilities[constantAction]<badThresh){
			badCount++;
		} else if (possibleUtilities[constantAction]>goodThresh) {
			goodCount++;
		}
		if(goodCount > goodCutoff){
			badCount=0;
		}
		if(badCount > badCutoff){
			constantAction = sampleActions();
			badCount=0;
		}
	}

	@Override
	public int getAction() {
		// TODO Auto-generated method stub
		return constantAction;
	}

}
