package analysis;
import java.util.Random;


public class LemonadeGameGenerator implements GameGeneratorInterface{
  
  @Override
  public ThreePlayerGame generateGame(Random r, int numActions) {
    ThreePlayerGame g = new ThreePlayerGame(numActions);
    int[] people = new int[numActions];
    for(int i=0;i<people.length;i++){
      people[i]=(1+r.nextInt(3))*6;
    }
    for(int i=0;i<numActions;i++){
      for(int j=0;j<numActions;j++){
        for(int k=0;k<numActions;k++){
          setUtility(g,i,j,k,people);
        }
        
      }
      
    }
    return g;
  }

  private int getDistance(int posA, int posB, int numActions){
    final int low;
    final int high;
    if (posA<posB){
      low = posA;
      high = posB;
    } else {
      high = posA;
      low = posB;
    }
    final int basic = high-low;
    final int special = (low+numActions)-high;
    return Math.min(basic, special);
    
  }
  private void setUtility(ThreePlayerGame g, int i, int j, int k, int[] people) {
    int[] values = g.getUtility(i, j, k);
    values[0]=values[1]=values[2]=0;
    for(int person=0;person<people.length;person++){
      int numPerson = people[person];
      int distI = getDistance(i,person,people.length);

      int distJ = getDistance(j,person,people.length);
      int distK = getDistance(k,person,people.length);
      if (distI<distJ){
        if (distK<distI){
          // distK<distI<distJ
          values[2]+=numPerson;
        } else if (distI<distK){
          // distI<distK,distI<distJ
          values[0]+=numPerson;
        } else {
          // distI==distK<distJ
          values[0]=numPerson/2;
          values[2]=numPerson/2;
        }
      } else if (distJ<distI){
        if (distK<distJ){
          // distK<distJ<distI
          values[2]+=numPerson;
        } else if (distJ<distK){
          // distJ<distK,distI<distK
          values[1]+=numPerson;
        } else {
          // distK=distJ<distI          
          values[1]=numPerson/2;
          values[2]=numPerson/2;
        }
        
      } else {
        // distI==distJ
        if (distK<distJ){
          // distK<distJ==distI
          values[2]+=numPerson;
        } else if (distJ<distK){
          // distJ==distI<distK
          values[0]+=numPerson/2;
          values[1]+=numPerson/2;
        } else {
          // distK==distJ==distI          
          values[0]=numPerson/3;
          values[1]=numPerson/3;
          values[2]=numPerson/3;
        }
        
      }
    }
    
  }

  
}
