package com.yahoo.lsg.lifelong;

public class DoubleRandomVariable {
  double total;
  double totalOfSquares;
  long repeats;
  
  public void add(double example){
    total = total+example;
    totalOfSquares = totalOfSquares + (example * example);
    repeats++;
    
  }
  
  
  public String toString(){
    if (repeats<1){
      return "?";
    } else {
      return getMean()+"+/-"+getSampleStandardDeviation();
    }
    
  }
  public DoubleRandomVariable(){
    total = 0;
    totalOfSquares = 0;
    repeats = 0;
  }
  
  public double getMean(){
    return ((double)total)/(repeats);
  }
  
  double getSampleStandardDeviation(){
    double average = getMean();
    double squareOfAverage = average * average;
    double averageOfSquares = ((double)totalOfSquares)/repeats;
    return Math.sqrt((averageOfSquares-squareOfAverage)*repeats/(repeats-1));
  }
  
  public double getStandardErrorOfTheMean(){
    return getSampleStandardDeviation()/Math.sqrt(repeats);
  }
  
  
}
