package com.yahoo.lsg.lifelong;

import com.yahoo.lsg.lifelong.observer.LifelongObserver;

import game.Game;

public class LifelongMatchup {
  LifelongStrategy[] sequence;
  PlayerIdentity []record;
  
  public LifelongMatchup(PlayerIdentity... record){
    this.record = record;
    this.sequence = new LifelongStrategy[record.length];
    for(int i=0;i<sequence.length;i++){
      sequence[i]=record[i].strategy;
    }
  }
  
  public void playMatch(Game g, int iterations, LifelongObserver observer){
    final int[] actions = new int[sequence.length];
    final int[][] rotatedActions = new int[sequence.length][sequence.length];
    
    for(int j=0;j<sequence.length;j++){
      sequence[j].newGame(g,iterations);
    }
    observer.newGame(g, record);
    
    
    for(int i=0;i<iterations;i++){
      for(int j=0;j<sequence.length;j++){
        actions[j]=sequence[j].getAction();
      }
      observer.observeOutcome(actions);
      for(int j=0;j<sequence.length;j++){
        for(int k=0;k<sequence.length;k++){
          rotatedActions[j][k]=actions[k];
        }
        rotatedActions[j][j]=actions[0];
        rotatedActions[j][0]=actions[j];
        sequence[j].observeOutcome(rotatedActions[j]);
      }
    }
    
  }
}
