package game;


/**
 * A strategy for a player. All players view the game as if
 * they are player 0. A class implementing the strategy
 * type should also implement a constructor of the form
 * MyClass(game.Game game, long randomSeed, String options)
 * 
 * @author maz
 *
 */
public interface Strategy {
  public int getAction();
  public void observeOutcome(int[] actions);
  
}
