package net;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.net.SocketException;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

public class ChatPanel extends JPanel implements ChatListener,ActionListener {
  JScrollPane scroll;
  JTextField entry;
  JTextArea display;
  private HumanRemoteClient client;
  public ChatPanel(HumanRemoteClient client){
    this.client = client;
    if (client!=null){
      client.setChatPanel(this);
    }
    setLayout(new BorderLayout());
    entry = new JTextField();
    display = new JTextArea(4,40);
    scroll = new JScrollPane(display);
    display.setEditable(false);
    display.setDisabledTextColor(Color.black);
    add(entry,BorderLayout.NORTH);
    
    //add(display,BorderLayout.CENTER);
    add(scroll,BorderLayout.CENTER);
    entry.addActionListener(this);
  }
  /**
   * 
   */
  private static final long serialVersionUID = 1L;

  public void handleChat(String chat) {
    String stringToPrint = chat.substring("CHAT:".length());
    display.append(stringToPrint+"\n");
    display.setCaretPosition(display.getDocument().getLength());
    
    /*Dimension size = display.getSize();
    Dimension sizeB = scroll.getSize();
    System.out.println(size);
    System.out.println(sizeB);
    if (sizeB.height>size.height){
      return;
    }
    int positionX = size.height-sizeB.height;
    Rectangle rect = new Rectangle(positionX,0,sizeB.height,sizeB.width);
    System.out.println(rect);
    display.scrollRectToVisible(rect);*/
    /*JScrollBar bar = scroll.getVerticalScrollBar();
    
    if (bar!=null){
      System.out.println("Adjusting bar's value to "+bar.getMaximum());
      bar.setValue(bar.getMaximum());
    }*/
  }

  public void actionPerformed(ActionEvent arg0) {
    String message = entry.getText();
    entry.setText("");
    //display.append(message+"\n");
    if (client!=null){
      try {
        client.sendMessage("CHAT:"+message);
      } catch (SocketException e) {
        // TODO Auto-generated catch block
        e.printStackTrace();
      } catch (IOException e) {
        // TODO Auto-generated catch block
        e.printStackTrace();
      }
    }
    
  }

}
