package net;


import game.Game;
import game.Strategy;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketException;

import util.Array;

import lemonade.ScaledLemonadeUtility;


/**
 * May be brought back to life after HumanRemoteClient and the protocol 
 * has stabilized.
 * @deprecated
 * @author maz
 *
 */
public class RemoteClient implements Runnable{
  Socket s;
  InputStream is;
  OutputStream os;
  Strategy strategy;
  /**
   * The current message terminator is CR LF (13 10).
   */
  public static final String messageTerminator = "" + ((char)13)+((char)10);
  boolean initialized;
  public RemoteClient(Strategy strategy) {
    this.strategy = strategy;
    initialized = false;
    Thread t = new Thread(this);
    t.start();
  }
  
  boolean matchOver = false;
  /**
   * Send a message to the server. Appends a message terminator (period).
   */
  public synchronized void sendMessage(String message) throws SocketException,IOException{
      showVerbose("CLIENT SENDS:"+message);
      message = message + messageTerminator;
      byte[] messageData = message.getBytes();
      if (!matchOver){
          os.write(messageData);
      }
  }
  
  /**
   * Receive a message from the server. Removes a message terminator (period).
   */
  public String receiveMessage() throws SocketException, IOException{
      String response = "";
      do{
          char c = (char)(is.read());
          //System.out.println("READ:"+(int)c);
          response = response + c;
          
      } while(!isComplete(response));
      response = response.substring(0,response.length()-messageTerminator.length());
      showVerbose("CLIENT RECEIVES:"+response);
      return response;
  }
  
  public void showVerbose(String string){
    System.err.println(string);
  }
  /**
   * Test if the message is complete (contains a terminal character)
   */
  public boolean isComplete(String result){
      return result.endsWith(messageTerminator);
  }
  
  public void run() {
    try {
      Socket s = new Socket();
      InetSocketAddress addr = new InetSocketAddress("localhost",5000);
      s.connect(addr);
      is = s.getInputStream();
      os = s.getOutputStream();
      while(true){
      int action = strategy.getAction();
      sendMessage(""+action);
      
      String response = receiveMessage();
      
      String[] responseParts = response.split(":");
      boolean gameOver = (responseParts[0].equals("GAMEOVER"));
      boolean gameAbort = (responseParts[0].equals("ABORT"));
      
      String[] outcomes = responseParts[1].split(" ");
      int[] intOutcomes = new int[outcomes.length];
      for(int i=0;i<outcomes.length;i++){
        intOutcomes[i]=Integer.parseInt(outcomes[i]);
      }
      System.out.println("Outcome:"+Array.arrayToNakedString(intOutcomes));
      strategy.observeOutcome(intOutcomes);
      if (gameOver || gameAbort){
        break;
      }

      }
    } catch (IOException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }
  }
  
  
  public static void main(String[] args){
    Game g = new Game(new int[]{12,12,12},new ScaledLemonadeUtility(12));
    Strategy constantStrategy = new net.HumanStrategy(g,0,"");
    new RemoteClient(constantStrategy);
  }
  
  

}
