package results;
import java.io.PrintStream;
import java.util.Vector;


public class PairTable {
  long[][][] data;
  String[] names;

  public int getNameIndex(String name){
    for(int index=0;index<names.length;index++){
      if (names[index].equals(name)){
        return index;
      }
    }
    return -1;
  }
  
  public void update(TripleResults result, int index0, int index1, int index2){
    int[] indices = new int[result.playerNames.length];
    for(int i=0;i<indices.length;i++){
      indices[i]=getNameIndex(result.playerNames[i]);
      if (indices[i]==-1){
        return;
      }
    }
    data[indices[index0]][indices[index1]][0]+=result.scores[index0];
    data[indices[index0]][indices[index1]][1]+=result.scores[index1];
    data[indices[index0]][indices[index1]][2]+=result.scores[index2];
    
  }
  public PairTable(String[] names, Vector<TripleResults> results){
    this.names = new String[names.length];
    for(int i=0;i<names.length;i++){
      this.names[i]=names[i];
    }
    data = new long[names.length][names.length][3];
    for(TripleResults result:results){
      update(result,0,1,2);
      update(result,0,2,1);
      update(result,1,0,2);
      update(result,1,2,0);
      update(result,2,0,1);
      update(result,2,1,0);
    }
  }
  
  
  public static String getValue(long original, double scale){
    double value = (double)original*scale;
    return String.format("%2.3g", value-8.0);
  }
  public void display(PrintStream stream){
    stream.print("This puts all games involving a pair of players in a single table entry.<BR>");
    stream.print("Numbers are points per round - 8<BR>");
    stream.print("Order is row player,column player, others<BR>");
    
    stream.print("<TABLE><TR><TD></TD>");
    for(String name:names){
      stream.print("<TD>"+name+"</TD>");
    }
    stream.println("</TR>");
    for(int i=0;i<names.length;i++){
      stream.print("<TR><TD>"+names[i]+"</TD>");
      for(int j=0;j<names.length;j++){
        if (i==j){
          stream.print("<TD></TD>");
        } else {
          long total = data[i][j][0]+data[i][j][1]+data[i][j][2];
          double scale = 24.0/total;
          stream.print("<TD>"+getValue(data[i][j][0],scale)+","+getValue(data[i][j][1],scale)+","+getValue(data[i][j][2],scale)+"</TD>");
        }
      }
      stream.println("</TR>");
    }
  }


}
