package results;
import java.util.Collections;
import java.util.Comparator;
import java.util.Hashtable;
import java.util.Map;
import java.util.Vector;


public class PlayerValue<C extends Comparable<C>> implements Comparable<PlayerValue<C>>{
  public PlayerValue(String name, C value) {
    super();
    this.name = name;
    this.value = value;
  }

  String name;
  C value;

  public String getName(){
    return name;
  }
  
  public C getValue(){
    return value;
  }
  public int compareTo(PlayerValue<C> o) {
    return value.compareTo(o.value);
  }
  
  public static <C extends Comparable<C>> Vector<PlayerValue<C>> getSorted(Hashtable<String,C> totals){
    Vector<PlayerValue<C>> sorted = new Vector<PlayerValue<C>>();
    
    //TreeVectorMap<Long,String> sorted = new TreeVectorMap<Long,String>();
    for(Map.Entry<String,C> total:totals.entrySet()){
      sorted.add(new PlayerValue<C>(total.getKey(),total.getValue()));
    }
    Collections.sort(sorted);
    return sorted;
  }
  
}
