package stats.collusion;

import stats.SeriesObserver;
import game.Game;
import game.Utility;


/**
 * An observer of utility, like jointactionutility, that does
 * not keep track of joint actions, simply utilities.
 * @author maz
 *
 */
public class GeneralSandwichCollusionObserver implements SeriesObserver{
  int[] lastActions;
  int[] thisActions;
  
  int[] constantSandwiched;
  int[] suddenlySandwiched;
  
  int numActions;
  Utility utility;
  
  static final int safeValue = 6;
  boolean firstRound;
  public GeneralSandwichCollusionObserver(Game g){
    
    if (g.getNumPlayers() != 3){
      throw new RuntimeException("There are not three players");
    }
    utility = g.getUtility();
    numActions  = (g.getNumActions());
    lastActions = new int[3];
    thisActions = new int[3];
    constantSandwiched = new int[3];
    suddenlySandwiched = new int[3];
    firstRound = true;
  }
  
  
    
  
  
  
  
    
  
  public boolean isCurrentlySandwiched(int player){
    int[] util = utility.getUtility(thisActions);
    return util[player]<safeValue;
  }

  public void observeOutcome(int[] actions){
    System.arraycopy(thisActions, 0, lastActions, 0, thisActions.length);
    System.arraycopy(actions, 0, thisActions, 0, thisActions.length);
    for(int i=0;i<thisActions.length;i++){
      if (isCurrentlySandwiched(i)){
        if ((!firstRound) && (thisActions[i]==lastActions[i])){
          this.constantSandwiched[i]++;
        } else {
          this.suddenlySandwiched[i]++;
        }
      }
    }
    firstRound = false;
  }






  public static String getString(int[] counts){
    StringBuilder builder = new StringBuilder("[");
    if (counts.length>=1){
      builder.append(counts[0]);
    }
    
    for(int j=1;j<counts.length;j++){
      builder.append(","+counts[j]);
    }
    builder.append("]");
    return builder.toString();
  }


  @Override
  public void display(String[] playerNames) {
    System.out.print("{playerNames:["+playerNames[0]+","+playerNames[1]+","+playerNames[2]+"],");
    System.out.print("constantSandwiched:"+getString(constantSandwiched)+",");
    System.out.println("suddenlySandwiched:"+getString(suddenlySandwiched)+"}");
  }








  @Override
  public void finishGame() {
    // TODO Auto-generated method stub
    firstRound = true;
  }








  @Override
  public void finishSeries() {
    // TODO Auto-generated method stub
    
  }









  @Override
  public void startGame(Game g) {
    // TODO Auto-generated method stub
    
  }
  
}
