package analysis;
import static org.junit.Assert.*;

import java.util.Random;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;


public class TruncatedUniformDistributionTest {
  TruncatedUniformDistribution dist;

  @Before
  public void setup(){
    dist = new TruncatedUniformDistribution();
  }

  @After
  public void tearDown(){
    dist = null;
  }

  @Test
  public void testGetProbabilityEqualTo() {
    double probEqualTo = dist.getProbabilityEqualTo(5, 10);
    double probLessThanOrEqualTo5 = dist.getProbabilityLessThanOrEqualTo(5, 10);
    double probLessThanOrEqualTo4 = dist.getProbabilityLessThanOrEqualTo(4, 10);
    assertEquals(probEqualTo,probLessThanOrEqualTo5-probLessThanOrEqualTo4,0.0001);
  }

  @Test
  public void testGetProbabilityLessThanOrEqualTo() {

    double result = dist.getProbabilityLessThanOrEqualTo(10, 10);
    assertEquals(1.0,result,0.0001);
  }

  @Test
  public void testGetProbabilitySuccess() {
    fail("Not yet implemented");
  }

  @Test
  public void testDartToValue() {
    int target = 0;
    for(double d=0.0;d<1.0;d+=0.001){
      int newTarget = dist.dartToValue(d,10);
      assertTrue(newTarget>=target);
      assertTrue(newTarget<=target+1);
      target=newTarget;
    }
    
  }

  @Test
  public void testGenerateUtilities() {
    int[][]counts = new int[3][11];
    int[] values = new int[3];
    Random r = new Random(0);
    for(int i=0;i<10000;i++){
      dist.generateUtilities(values, 10, r);
      counts[0][values[0]]++;
      counts[1][values[1]]++;
      counts[2][values[2]]++;
    }
    for(int i=0;i<counts[0].length;i++){
      assertTrue(Math.abs(counts[0][i]-counts[1][i])<100);
      assertTrue(Math.abs(counts[0][i]-counts[1][i])<100);
      assertTrue(Math.abs(counts[1][i]-counts[2][i])<200);

    }
  }

}
