package results;

import static org.junit.Assert.*;

import java.io.File;
import java.util.Vector;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class SimulateLemonadeTournamentTest {

  SimulateLemonadeTournament tournament;
  @Before
  public void setUp() throws Exception {
    tournament = new SimulateLemonadeTournament(new File("results/metaOnlyGame.txt"),100);
  }

  @After
  public void tearDown() throws Exception {
    tournament = null;
  }

  @Test
  public void testGetTriple() {
    TripleResults results = tournament.getTriple(new String[]{"rlcubed.CoOpp","rlcubed.CoOpp","rlcubed.CoOpp"});
    assertEquals(100,results.repeats);
    assertEquals("rlcubed.CoOpp",results.playerNames[0]);
    assertEquals(78912,results.scores[0]);
  }

  @Test
  public void testMapTriple() {
    TripleResults results = tournament.mapTriple(new String[]{"alice","bob","charlie"},new String[]{"rlcubed.CoOpp","rlcubed.CoOpp","rlcubed.CoOpp"});
    assertEquals(100,results.repeats);
    assertEquals("alice",results.playerNames[0]);
    assertEquals(78912,results.scores[0]);
  }

  @Test
  public void testRunAsymmetricNonSelfPlayTournamentStringArrayStringArray() {
    Vector<TripleResults> results = tournament.runAsymmetricNonSelfPlayTournament(new String[]{"alice","bob","charlie"}, new String[]{"rlcubed.CoOpp","rlcubed.CoOpp","rlcubed.CoOpp"});
    TripleResults result = results.get(0);
    assertEquals(100,result.repeats);
    assertEquals("alice",result.playerNames[0]);
    assertEquals(78912,result.scores[0]);
  }


}
