/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.ualberta.rggibson;
import game.Utility;

/**
 *
 * @author Richard
 */
public class BehaviourConstantAfter extends BehaviourModel
{
    int player;
    int prevAction;
    boolean afterGood;
    boolean available;

    Utility utilFunc;

    public BehaviourConstantAfter(int player, Utility util, boolean afterGood)
    {
        super();

        this.player = player;
        this.afterGood = afterGood;
        utilFunc = util;

        prevAction = 0;
        available = false;
    }

    public String getName()
    {
        if (afterGood)
        {
            return "ConstantAfterGood";
        }
        else
        {
            return "ConstantAfterBad";
        }
    }

    public int[] getActionList()
    {
        assert (isAvailable());
        int[] action = { prevAction };
        return action;
    }

    public boolean isAvailable()
    {
        return available;
    }

    public void update(int[] actions, boolean doUpdateCounts)
    {
        // Update counts and weight
        if (doUpdateCounts && available)
        {
            count *= DECAY;
            maxCount *= DECAY;

            if (actions[player] == prevAction)
            {
                count += 1;
            }
            maxCount += 1;

            weight = count / maxCount;
        }

        prevAction = actions[player];

        if (utilFunc.getUtility(actions)[player] >= 8)
        {
            available = afterGood;
        }
        else
        {
            available = (!afterGood);
        }
    }

    public BehaviourModel clone()
    {
        BehaviourConstantAfter bm = new BehaviourConstantAfter(player, utilFunc, afterGood);

        bm.count = count;
        bm.maxCount = maxCount;
        bm.weight = weight;
        bm.prevAction = prevAction;
        bm.available = available;

        return bm;
    }
}
