/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.ualberta.rggibson;

/**
 *
 * @author Richard
 */
public class BehaviourMatching extends BehaviourModel
{
    int player;
    int target;
    int numActions;

    int nextAction;

    public BehaviourMatching(int numActions, int player, int target)
    {
        super();

        this.numActions = numActions;
        this.player = player;
        this.target = target;

        nextAction = -1;
    }

    public String getName()
    {
        String name = "Matching";
        if (target == 0)
        {
            name += "Me";
        }
        else
        {
            name += "Opp";
        }

        return name;
    }

    public int[] getActionList()
    {
        assert (isAvailable());
        int[] actions = { nextAction };
        return actions;
    }

    public boolean isAvailable()
    {
        return (nextAction == -1 ? false : true);
    }

    public void update(int[] actions, boolean doUpdateCounts)
    {
        // Update the counts and weight
        if (doUpdateCounts && isAvailable())
        {
            count *= DECAY;
            maxCount *= DECAY;

            if (actions[player] == nextAction)
            {
                count += 1;
            }

            maxCount += 1;

            weight = count / maxCount;
        }

        // Update the next action
        int otherOpp = 3 - player - target;
        if (actions[target] == actions[otherOpp])
        {
            // This behaviour is not available after the others sit on each other
            nextAction = -1;
        }
        else
        {
            int diff = actions[target] - actions[otherOpp];
            nextAction = UctBehaviourModeller.mod(actions[otherOpp] - diff, numActions);
        }
    }

    public BehaviourModel clone()
    {
        BehaviourMatching bm = new BehaviourMatching(numActions, player, target);

        bm.count = count;
        bm.maxCount = maxCount;
        bm.weight = weight;
        bm.nextAction = nextAction;

        return bm;
    }
}
