/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.ualberta.rggibson;
import game.Utility;

/**
 *
 * @author Richard
 */
public class BehaviourSitOnAfterBad extends BehaviourModel
{
    int player;
    int target;
    Utility utilFunc;

    int nextAction;
    boolean available;

    public BehaviourSitOnAfterBad(int player, int target, Utility util)
    {
        super();

        this.player = player;
        this.target = target;
        utilFunc = util;

        nextAction = -1;
        available = false;
    }

    public String getName()
    {
        if (target == 0)
        {
            return "SitOnMeAfterBad";
        }
        else
        {
            return "SitOnOppAfterBad";
        }
    }

    public int[] getActionList()
    {
        assert (isAvailable());
        int[] action = { nextAction };
        return action;
    }

    public boolean isAvailable()
    {
        return available;
    }

    public void update(int[] actions, boolean doUpdateCounts)
    {
        // Update counts and weight
        if (doUpdateCounts && available)
        {
            count *= DECAY;
            maxCount *= DECAY;

            if (actions[player] == nextAction)
            {
                count += 1;
            }
            maxCount += 1;

            weight = count / maxCount;
        }

        nextAction = actions[target];

        if (utilFunc.getUtility(actions)[player] < 8)
        {
            available = true;
        }
        else
        {
            available = false;
        }
    }

    public BehaviourModel clone()
    {
        BehaviourSitOnAfterBad bm = new BehaviourSitOnAfterBad(player, target, utilFunc);

        bm.count = count;
        bm.maxCount = maxCount;
        bm.weight = weight;
        bm.nextAction = nextAction;
        bm.available = available;

        return bm;
    }
}
